/*
 * timer.c
 *
 *  angepasst fr die Stoppuhr am: 16.08.2013
 */

#include "main.h"

// Initialisiert TimerA auf 0,9765625ms Ticks
void vTimerA_init(void) {
	TACTL = TASSEL_1 + TACLR; //ACLK, Div=1, Clear TAR
	TACCR0 = 32; //ticks all ca. 1ms for countig and debouncing of keys
	TACCTL0 = CCIE, //Interrupt enable
	TACTL |= MC_2; //Start Timer_A in continous up mode (up to 0xffff)
}

//****** Timer-Interrupt-Service-Routine A0, wird alle 0,9765625ms aufgerufen ********
#pragma vector=TIMER0_A0_VECTOR				//Timer0 ISR
__interrupt void Timer0_A0(void) {
	TACCR0 += 32; //in ca. 1ms erneut aufrufen

	if (status == Messung) {
		++tickzaehler;
	} else if (status == StandBy) {
		tickzaehler = 0;
	}

	switch (keyStatus) {
	case Reading:
		switch (status) {
		case Messung:
			if (KeyPort & Key1Bit) { // Taste losgelassen
				status = Stopped;
			}
			break;
		case StandBy:
			if (!(KeyPort & Key1Bit)) { // Taste gedrckt
				status = Messung;
				keyStatus = Debouncing;
			}
			break;
		default:
			break;
		}
		break;
	case Debouncing:
		if (tickzaehler > 13) { // 10 htte fr das Entprellen auch gereicht, hier aber 13 wg. H13
			keyStatus = Reading;
		}
		break;
	default:
		break;
	}
	_bic_SR_register_on_exit(CPUOFF);
}

// Ende timer.c
